;; merlin/util.jl -- some utilities

;; version 0.1

;; Copyright (C) 2000 merlin <merlin@merlin.org>

;; http://merlin.org/sawfish/

;; this is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; this is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure merlin.util

  (export
   fontify
   colorify
   wm-initialized
   percent
   assqd)

  (open
   rep
   rep.system
   sawfish.wm.colors
   sawfish.wm.fonts
   sawfish.wm.windows)

  ;; string/font -> font
  (define (fontify font)
    (if (stringp font) (get-font font) font))

  ;; string/color -> color
  (define (colorify color)
    (if (stringp color) (get-color color) color))

  (define after-initialization nil)

  (add-hook 'after-initialization-hook
    (lambda () (setq after-initialization t)))

  ;; is the window manager initialized yet
  (define (wm-initialized) ;; a hack
    (or after-initialization (managed-windows)))

  ;; b percent of a
  (define (percent a b)
    (quotient (* a b) 100))

  ;; assq with default
  (define (assqd key alist default)
    (if (assq key alist)
      (assq key alist)
      (cons key default))))
